package com.jersey.series.pathparam;

import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

@Path("bookservice")
public class BookServiceImpl implements IBookService {

	// http://localhost:8080/Jersey-PathParam/rest/bookservice/book/LifeSciences
	@GET
	@Path("book/{name}")
	@Consumes({MediaType.TEXT_PLAIN})
	@Produces({MediaType.TEXT_PLAIN})
	public Response printBookName(@PathParam("name") String bookName) {

		String bookDetail = "Book name is " + bookName;
		return Response.status(200).entity(bookDetail).build();
	}

	// http://localhost:8080/Jersey-PathParam/rest/bookservice/bookdetail/Enzymology/Devasena/Biochemistry
	@GET
	@Path("bookdetail/{name}/{author}/{category}")
	@Consumes({MediaType.TEXT_PLAIN})
	@Produces({MediaType.TEXT_PLAIN})
	public Response printCompleteBookDetails(
			@PathParam("name") String bookName, 
			@PathParam("author") String author, 
			@PathParam("category") String category) {

		String bookCompleteDetail = "Book complete detail [Name=" + bookName +  ", Author=" + author + ", Category=" + category + "]";
		return Response.status(200).entity(bookCompleteDetail).build();
	}
}